---
title: RTCOfferOptions.iceRestart
slug: Web/API/RTCOfferOptions/iceRestart
tags:
  - Configuration
  - ICE
  - ICE Restart
  - Offer
  - Option
  - Property
  - RTCOfferOptions
  - Reference
  - SDP
  - Setting
  - WebRTC
  - WebRTC API
  - iceRestart
---
<div>{{APIRef("WebRTC")}}</div>

<p>The <code><strong>iceRestart</strong></code> property of the <strong>{{domxref("RTCOfferOptions")}}</strong> dictionary is a Boolean value which, when <code>true</code>, tells the {{domxref("RTCPeerConnection")}} to start ICE renegotiation.</p>

<div class="notecard note">
<p><strong>Note:</strong> Rather than manually creating and submitting an offer with <code>iceRestart</code> set to <code>true</code>, you should consider calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.restartIce", "restartIce()")}} instead.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>options</em> = {
  iceRestart: <em>trueOrFalse</em>
};
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value indicating whether or not the <code>RTCPeerConnection</code> should generate new values for the connection's ice-ufrag and ice-pwd values, which will trigger ICE renegotiation on the next message sent to the remote peer.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>When the {{domxref("RTCPeerConnection")}} object's ICE connection state changes to <code>failed</code>, you should try to trigger an <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#ICE_restart">ICE restart</a>. You should ideally do this by calling the {{domxref("RTCPeerConnection")}}'s {{domxref("RTCPeerConnection.restartIce", "restartIce()")}} method, if it's available.</p>

<p>Fundamentally, this renegotiation is triggered by generating and using new values for the ICE username fragment ("ufrag")}}</p>

<h2 id="Example"><span>Example</span></h2>

<p>This example shows a handler for the {{event("iceconnectionstatechange")}} event. It watches for the ICE connection state to transition to <code>"failed"</code>, which indicates that an ICE restart should be tried in order to attempt to bring the connection back up.</p>

<pre class="brush: js notranslate">pc.oniceconnectionstatechange = function(evt) {
  if (pc.iceConnectionState === "failed") {
    if (pc.restartIce) {
      pc.restartIce();
    } else {
      pc.createOffer({ iceRestart: true })
      .then(pc.setLocalDescription)
      .then(sendOfferToServer);
    }
  }
}
</pre>

<p>If the state changes to <code>failed</code>, this handler starts by looking to see if the {{domxref("RTCPeerConnection")}} includes the {{domxref("RTCPeerConnection.restartIce", "restartIce()")}} method; if it does, we call that to request an ICE restart. Otherwise, we call back to the older technique: we manually create a new offer with <code>iceRestart</code> set to <code>true</code>, then that offer is set as the new local description for the connection. After that, the offer is sent to the server by calling a custom function <code>sendOfferToServer()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcofferoptions-icerestart', 'RTCOfferOptions.iceRestart')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCOfferOptions.iceRestart")}}</p>
